/**
 * @file src/test_r_binding.cpp
 *
 * This is an autogenerated file containing implementations of C++ functions to
 * be called by the R test_r_binding binding.
 */
#include <rcpp_mlpack.h>
#define BINDING_TYPE BINDING_TYPE_R
#include <mlpack/bindings/R/tests/test_r_binding_main.cpp>

// [[Rcpp::export]]
void test_r_binding_mlpackMain()
{
  mlpackMain();
}

// Any implementations of methods for dealing with model pointers will be put
// below this comment, if needed.

// Get the pointer to a GaussianKernel parameter.
// [[Rcpp::export]]
SEXP IO_GetParamGaussianKernelPtr(const std::string& paramName)
{
  return std::move((Rcpp::XPtr<GaussianKernel>) IO::GetParam<GaussianKernel*>(paramName));
}

// Set the pointer to a GaussianKernel parameter.
// [[Rcpp::export]]
void IO_SetParamGaussianKernelPtr(const std::string& paramName, SEXP ptr)
{
  IO::GetParam<GaussianKernel*>(paramName) =  Rcpp::as<Rcpp::XPtr<GaussianKernel>>(ptr);
  IO::SetPassed(paramName);
}

// Serialize a GaussianKernel pointer.
// [[Rcpp::export]]
Rcpp::RawVector SerializeGaussianKernelPtr(SEXP ptr)
{
  std::ostringstream oss;
  {
    boost::archive::binary_oarchive oa(oss);
    oa << boost::serialization::make_nvp("GaussianKernel",
          *Rcpp::as<Rcpp::XPtr<GaussianKernel>>(ptr));
  }

  Rcpp::RawVector raw_vec(oss.str().size());

  // Copy the string buffer so we can return one that won't get deallocated when
  // we exit this function.
  memcpy(&raw_vec[0], oss.str().c_str(), oss.str().size());
  raw_vec.attr("type") = "GaussianKernel";
  return raw_vec;
}

// Deserialize a GaussianKernel pointer.
// [[Rcpp::export]]
SEXP DeserializeGaussianKernelPtr(Rcpp::RawVector str)
{
  GaussianKernel* ptr = new GaussianKernel();

  std::istringstream iss(std::string((char *) &str[0], str.size()));
  {
    boost::archive::binary_iarchive ia(iss);
    ia >> boost::serialization::make_nvp("GaussianKernel", *ptr);
  }

  // R will be responsible for freeing this.
  return std::move((Rcpp::XPtr<GaussianKernel>)ptr);
}


